# frozen_string_literal: true

module ElasticsearchHermes
  module Indexing
    module Helper
      def re_index(index_name: to_s.underscore)
        delete_index(index_name: index_name)
        @index_object.create
        all.find_each(&:touch)
      end

      def delete_index(index_name: to_s.underscore)
        @index_object ||= ElasticsearchHermes::Index.new(name: index_name, fields: @fields)
        @index_object.delete
      rescue Elasticsearch::Transport::Transport::Errors::NotFound
        Logger.log("No Such index: #{index_name}")
      end

      def index_on(fields: [])
        @fields = fields
      end
    end
  end
end
