# frozen_string_literal: true

module ElasticsearchHermes
  module Indexing
    module Model
      def elastic_update(type: '_doc', index_name: self.class.to_s.underscore, id:, body:)
        ElasticsearchHermes.client.index index_payload(
          index_name: index_name,
          type: type,
          body: body,
          id: id
        )
      end

      def index_payload(index_name:, type:, id:, body:)
        {
          type: type,
          index: index_name,
          id: id,
          body: body
        }
      end
    end
  end
end
