# frozen_string_literal: true

module ElasticsearchHermes
  module Query
    def search(query: '', index_name: to_s.underscore, fields: @hermes_search_on)
      @results = ElasticsearchHermes.client.search query_payload(
        query: query,
        index_name: index_name,
        fields: fields
      )
      ElasticsearchHermes::Result::Base.new(@results.symbolize_keys)
    end

    def hermes_search_on(fields: [])
      @hermes_search_on ||= fields.map(&:to_s)
    end

    def search_type; end

    def field_type; end

    def minimum_match; end

    def query_payload(query:, index_name:, fields:)
      {
        index: index_name,
        body: {
          query: {
            multi_match: {
              query: query,
              fields: fields
            }
          }
        }
      }
    end
  end
end
