# frozen_string_literal: true

module ElasticsearchHermes
  module Result
    class Base
      attr_reader :took, :timed_out, :shards, :hits

      def initialize(took:, timed_out:, hits:, _shards:)
        @took = took
        @timed_out = timed_out
        @shards = _shards
        @hits = hits
      end

      def ids
        @ids ||= @hits['hits'].map { |hit| hit['_id'] }
      end

      def models
        @models ||= ''
      end
    end
  end
end
